//MUESTRA EL TEXTO DE 5 CARACTERES INICIALIZADO EN EL ARREGLO
//matrix[], EN LA MATRIZ 7X30, USANDO TECNICA DE MULTIPLEXAJE.
//HAY DISPONIBLES DOS CARACTERES GRAFICOS:"%&" ES UN CORAZON
//Y "/(" ES UNA FLECHA

#if defined(__PCM__)
#include "16f88adc.h"
#use delay (clock=4000000)
#use rs232 (baud=9600,xmit=PIN_B5,rcv=PIN_B2)
#rom 0X0000={0X018A,0X2803}         
#build(reset=0x0003)

void renglones(void);
void reset(void);
void pulso(void);
int i;					//variable ndice malla principal 
int k;					//variable ndice para arreglo pf[]
int bo;
int jota=0;				//variable indice para arreglo pf[]
#ORG 0X0400,0X40F
const char matrix[]="AMIGO";			//string con texto de 5 caracteres
char pf[30]; 
#include "LETRASCCS4.h"
void main()
{
bo=0;
SPEN=0;        //Apagamos el USART para poder usar el puerto B.
CVRCON=0;
CMCON=7;
TRISA=0;    //Configuramos puertos.
TRISB=0;
PORTA=0;
PORTB=0;
reset();
for(k=0;k<5;k++)
	{
	swatch(matrix[k]);		//acomoda patrn de columnas en arreglo pf[]
	if(matrix[k]=='%')goto sigue;  //si es caracter grfico,no aade rengn en blanco
	if(matrix[k]=='/')goto sigue2;
	pf[jota]=0;	
	jota=jota+1;					//deja una columna en blanco entre caracteres	
	continue;
	sigue:							//si es corazn, aade la columna que falta
	pf[jota]=0x3E;
	jota=jota+1;
	continue;
	sigue2:							//si es flecha, aade la columna que falta
	pf[jota]=0x38;
	jota=jota+1;	
	}	
   malla:     
   RA2=0;         //dato=0	para ingresar un 0 a primera columna
   pulso();       //COLUMNA 0=0 el 0 se va a ir corriendo al resto de las columnas
   RA2=1;         //dato=1  ingresan 1 a registros a cada incremento.
   for (i=0;i<=29;i++)     //Hacemos el barrido de columnas.
   {                                       
      bo=pf[i];            	//Barremos la variable que contiene los datos para escribir en las matrices.
      renglones();           //Manda el dato de 7 renglones.
      delay_us(700);
      pulso();             //activa siguiente columna 
	  PORTB=0;				//evita que encienda brevemente la sig. columna
      RA4=0; 
   }
goto malla;
			
}

//ASIGNA DATO EN RENGLON A BIT DE PUERTOS:
//R0=RB0,R1=RB1,R2=RB3,R3=RB4,R4=RB6,R5=RB7,R6=RA4
//RB2 Y RB5 SE RESERVAN PARA EL PUERTO SERIAL.
void renglones(void)
{
   PORTB=0;
   RA4=0;  
   if (bit_test(bo,1)==1)      //asigna valores a bits.
   {RB0=1;}   
   if (bit_test(bo,2)==1)
   {RB1=1;}
   if (bit_test(bo,3)==1)      
   {RB3=1;}
   if (bit_test(bo,4)==1)      
   {RB4=1;}
   if (bit_test(bo,5)==1)      
   {RB6=1;}
   if (bit_test(bo,6)==1)      
   {RB7=1;}
   if (bit_test(bo,7)==1)      
   {RA4=1;}   
}

void reset(void)
{
RA0=0;
delay_ms(100);
RA0=1;
}

void pulso(void)
{
RA1=0;
RA1=1;
}